%define module_name	kqemu
%define version	1.4.0
%define rel	8
%define snapshot	pre1
%define fullver	%{version}%{?snapshot:%{snapshot}}
%define dkmsver	%{fullver}-%{rel}
%define release	%mkrel %{?snapshot:0.%{snapshot}.}%{rel}
%ifarch %{ix86}
%define kqemu_program	qemu
%endif
%ifarch x86_64
%define kqemu_program	qemu-system-x86_64
%endif

Summary:	QEMU Accelerator Module
Name:		dkms-kqemu
Version:	%{version}
Release:	%{release}
Source0:	http://bellard.org/qemu/kqemu-%{fullver}.tar.gz
License:	GPL
URL:		http://bellard.org/qemu/
Group:		System/Kernel and hardware
Requires(post):	 dkms
Requires(preun): dkms
ExclusiveArch:	%{ix86} x86_64 
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
QEMU Accelerator (KQEMU) is a driver allowing the QEMU PC emulator to
run much faster when emulating a PC on an x86 host.

Full virtualization mode can also be enabled (with -kernel-kqemu) for
best performance. This mode only works with the following guest OSes:
Linux 2.4, Linux 2.6, Windows 2000 and Windows XP. WARNING: for
Windows 2000/XP, you cannot use it during installation.

Use "%{kqemu_program}" to benefit from the QEMU Accelerator Module.

%prep
%setup -q -n %{module_name}-%{fullver}

%build

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_usr}/src/%{module_name}-%{dkmsver}
tar cf - . | \
(cd $RPM_BUILD_ROOT%{_usr}/src/%{module_name}-%{dkmsver} && tar xf -)
cat > $RPM_BUILD_ROOT%{_usr}/src/%{module_name}-%{dkmsver}/dkms.conf << EOF
PACKAGE_NAME=%{module_name}
PACKAGE_VERSION=%{dkmsver}
MAKE[0]="./configure --kernel-path=/lib/modules/\${kernelver}/source && make"
DEST_MODULE_LOCATION[0]=/kernel/3rdparty/%{module_name}
BUILT_MODULE_NAME[0]=%{module_name}
AUTOINSTALL=yes
EOF

# install udev rules
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d/
cat > $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d/65-%{module_name}.rules << EOF
KERNEL=="%{module_name}", MODE="0666"
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post
set -x
/usr/sbin/dkms --rpm_safe_upgrade add -m %{module_name} -v %{dkmsver}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{module_name} -v %{dkmsver}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{module_name} -v %{dkmsver}
/sbin/modprobe %{module_name} >/dev/null 2>&1 || :

%preun
# rmmod can fail
/sbin/rmmod %{module_name} >/dev/null 2>&1
set -x
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{module_name} -v %{dkmsver} --all || :

%files
%defattr(-,root,root)
%doc README kqemu-doc.html kqemu-tech.html
%dir %{_usr}/src/%{module_name}-%{dkmsver}
%{_usr}/src/%{module_name}-%{dkmsver}/*
%_sysconfdir/udev/rules.d/65-%{module_name}.rules



%changelog
* Wed Jul 15 2009 Raphaël Gertz <rapsys@mandriva.org> 1.4.0-0.pre1.8mdv2010.0
+ Revision: 396480
- Rebuild
- Fix undefined variable %%{kqemu_dkmsver} in %%post scripts

* Thu Jul 09 2009 Pascal Terjan <pterjan@mandriva.org> 1.4.0-0.pre1.7mdv2010.0
+ Revision: 393944
- import dkms-kqemu


* Thu Jul 09 2009 Pascal Terjan <pterjan@mandriva.org> 1.4.0-0.pre1.6mdv2010.0
- Create a separate dkms-kqemu package

* Sun Mar 22 2009 Frederik Himpe <fhimpe@mandriva.org> 0.10.1-3mdv2009.1
+ Revision: 360260
- Update to new version 0.10.1

* Fri Mar 06 2009 Pascal Terjan <pterjan@mandriva.org> 0.10.0-2mdv2009.1
+ Revision: 349652
- Update to 0.10.0
- Enable ppc again

* Wed Feb 04 2009 Guillaume Rousse <guillomovitch@mandriva.org> 0.9.1-0.r5137.2mdv2009.1
+ Revision: 337395
- rediff vga patch
- keep bash completion in its own package

* Mon Sep 08 2008 Pascal Terjan <pterjan@mandriva.org> 0.9.1-0.r5137.1mdv2009.0
+ Revision: 282565
- Update to svn snapshot
- Drop KVM support (to be packaged separatly)
- Disable ppc for now

* Tue Apr 01 2008 Pascal Terjan <pterjan@mandriva.org> 0.9.0-18mdv2008.1
+ Revision: 191380
- try SDL, alsa, oss instead of oss, alsa, SDL

  + Anssi Hannula <anssi@mandriva.org>
    - add a comment regarding _requires_exceptions

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Sat Dec 08 2007 Per Øyvind Karlsen <peroyvind@mandriva.org> 0.9.0-17mdv2008.1
+ Revision: 116405
- backport OHCI & UHCI iso transfer support from git (should make webcams usable :)
- fix typo in bash completion (modified S3)

* Mon Oct 01 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-16mdv2008.0
+ Revision: 94272
- Add a link /usr/bin/qemu-kvm for compatibility with some other distros

* Sat Sep 22 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-15mdv2008.0
+ Revision: 92233
- Have the completion to add the common prefix (really handy to change iso during install)

* Fri Sep 21 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-14mdv2008.0
+ Revision: 91894
- Enable alsa support (and don't disable gcc version check twice)

* Mon Sep 17 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-13mdv2008.0
+ Revision: 89251
- Add mipsel system emulation

* Thu Sep 06 2007 Olivier Blin <oblin@mandriva.com> 0.9.0-12mdv2008.0
+ Revision: 80664
- fix "HSM violation" bug in ATAPI cdrom driver (from qemu CVS, Novell #291775, Ubuntu #120316)

* Mon Aug 20 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-11mdv2008.0
+ Revision: 67355
- Turn Requires dkms-kqemu into a Suggest

* Mon Aug 20 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-10mdv2008.0
+ Revision: 67187
- Drop cpu-vendor option from kvm patch for now, it breaks build on x86_64
- Update to kvm-35
- Add a patch from the ML to support USB devices with several interfaces

* Fri Aug 10 2007 Pascal Terjan <pterjan@mandriva.org> 0.9.0-9mdv2008.0
+ Revision: 61527
- Adapt the PXE patches and apply them

  + Erwan Velu <erwan@mandriva.org>
    - Adding patches to make pxe working

* Sat Jun 30 2007 Olivier Blin <oblin@mandriva.com> 0.9.0-8mdv2008.0
+ Revision: 46094
- fix __find_requires macro override
- really package bash_completion file (and thus fix build)
- do not mark initscript as config file

  + Guillaume Rousse <guillomovitch@mandriva.org>
    - bash completion

* Fri Apr 20 2007 Gwenole Beauchesne <gbeauchesne@mandriva.org> 0.9.0-7mdv2008.0
+ Revision: 16259
- rewrite patches for gcc4 support and use it everywhere

* Wed Apr 18 2007 Gwenole Beauchesne <gbeauchesne@mandriva.org> 0.9.0-6mdv2008.0
+ Revision: 14738
- fix pgtable calculation for 32-bit code under x86_64 (Bernhard Kauer)
- fix qcow2 image corruption, refcount table (Juergen Keil)
- fix build with gcc3.3 (Windows XP in i386-softmmu)


* Tue Mar 27 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.9.0-5mdv2007.1
+ Revision: 149237
- fix x86 fprem, aka fix konqueror in x86{,_64} guests (Julian Seward)
- propagate release to dkms config so that to handle upgrades gracefully
- don't try to load kvm module in xen0
- increase max -kernel size to 8 MB with -initrd (x86_64 guest, in particular)

* Thu Mar 15 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.9.0-4mdv2007.1
+ Revision: 144294
- kqemu 1.3.0pre11 (no change)
- fix linux-user emulation on x86_64
- disable "no-nptl" patch for MDV >= 2007.0
- add should-start: dkms to initscript (blino)
- add conflicts to ensure upgrades from MDV < 2007.1

* Wed Mar 14 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.9.0-3mdv2007.1
+ Revision: 143511
- split off qemu-img into another package
- make "qemu" the accelerator-capable binary on x86_64 too
- add KVM support (rev 4486)
- add live migration support (Anthony Liguori + KVM SVN)
- fix support for multi-threaded applications in linux-user

* Wed Feb 14 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.9.0-2mdv2007.1
+ Revision: 120890
- add support for vga= option with -kernel (Pascal Terjan)
- updates from CVS (2007/02/14):
  * fix SYSLINUX hang (reset rombios32 area)
  * fix floating point to integer conversion in sparc emulation
  * serial console improvements
  * increase USB table poll interval
  * more linux-user syscalls: prctl, syslog

* Tue Feb 06 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.9.0-1mdv2007.1
+ Revision: 116853
- 0.9.0
- integrate kqemu

* Sat Feb 03 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.8.3-0.20070203.1mdv2007.1
+ Revision: 116057
- 64-bit fixes (preserve host registers)
- x86_64 host improvements (+15%% on nbench.flp)
- remove qvm86 accelerator (obsolete and unmaintained)
- updates from CVS (2007/02/03):
  * fix x86_64 syscalls, cwde and cdq
  * add sem*() and msg*() to linux-user emulation
  * add PIIX4 SMBus host support, EEPROM device emulation

* Tue Jan 30 2007 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.8.3-0.20070118.1mdv2007.1
+ Revision: 115559
- 0.8.3 snapshot (2007/01/18)

* Mon Jul 24 2006 trem <trem@mandriva.org> 0.8.2-1mdv2007.0
- 0.8.2

* Thu Jul 20 2006 trem <trem@mandriva.org> 0.8.1-2mdv2007.0
- add Patch20 which fix a compile error
- add arm-softmmu as target

* Thu May 04 2006 trem <trem@mandriva.org> 0.8.1-1mdk
- 0.8.1
- remove useless patch

* Mon Feb 13 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.8.0-4mdk
- fix gcc4 hacks for 0.8.0
- enforce 16-byte stack boundaries
- try to enforce only one exit point per synthetic opcode
- assorted fixes from cvs (2006/02/12):
  * fxsave/fxrstor fix
  * kqemu and SMP are currently not compatible
  * make target_mmap always return -1 on failure
  * correct DMA and transfer mode reporting (Jens Axboe)

* Sun Feb 05 2006 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.8.0-3mdk
- add rtl8139 nic emulation (Igor Kovalenko)
- add support for nic card selection (-nic hw=ne2000|pcnet|rtl8139)
- fix but remove x86_64 softmmu asm opts as sizeof(CPUTLBEntry) is no
  longer of the form 2^n and thus requiring one more instruction that
  renders the optimization worthless

* Mon Jan 16 2006 trem <trem@mandriva.org> 0.8.0-2mdk
- Fix x86_64 compilation (disable patch x86_64-softmmu-asm)

* Tue Dec 20 2005 Pascal Terjan <pterjan@mandriva.org> 0.8.0-1mdk
- 0.8.0
- rediffed P8, P16
- merged P13 into P2
- dropped P12
- updated P11
- don't apply sheep-net patch for now, gb will do :)
- add patch by Paul Brook to speedup user-net (P19)

* Fri Oct 28 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.2-5mdk
- more gcc4 patches, disabled for now because of x86_64-softmmu

* Tue Oct 25 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.2-4mdk
- linux-user improvements:
  * add AT_PLATFORM & AT_HWCAP entries to auxiliary vector
  * forcibly disable use of NPTL for now since it's not emulated yet

* Tue Oct 11 2005 Pascal Terjan <pterjan@mandriva.org> 0.7.2-3mdk
- Enable building kqemu/qvm86 support (P12) :
  * don't require the sources of current kernel
  * as we don't know the kernel, enforce 2.6 build style

* Tue Oct 11 2005 Erwan Velu <erwan@seanodes.com> 0.7.2-2mdk
- Oops, 0.7.2-1mdk wasn't good :(
- importing newest kqemu.h
- qvm86 updates from CVS (2005/10/10)

* Mon Oct 10 2005 Erwan Velu <erwan@seanodes.com> 0.7.2-1mdk
- 0.7.2
- Rediffing to 0.7.2
- patch13 is merged upstream

* Thu Aug 11 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.1-3mdk
- IDE fix from CVS for FreeBSD/AMD64 support
- run-time detect qvm86/kqemu and enable specific features accordingly
- qvm86 updates from CVS (2005/08/01):
  * performance improvements
  * add support for pae enabled host kernels

* Mon Jul 25 2005 Pascal Terjan <pterjan@mandriva.org> 0.7.1-2mdk
- use new kqemu.h from kqemu 
- enable kqemu support on x86_64 (P12)
- don't break x86_64 in P8 when kqemu is enabled

* Mon Jul 25 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.1-1mdk
- only use gcc3.3 in 2006+ and x86
- load initrd at a higher address in pc emulation
- 0.7.1:
  * fixes to sparc64 and ppc system emulation
  * add initial support for mips system emulation
  * fixes to i386 emulation: fscale, add overflow exceptions in divisions
  * fix 64-bit virtual addressing
  * allow more than 4 GB of physical memory
  * add IO-APIC support for Windows 64
  * add support for s390 hosts
  * linux-user improvements: more set/getsockopt values, [f]truncate64,

* Thu Jul 21 2005 Pascal Terjan <pterjan@mandriva.org> 0.7.0-8mdk
- add AMD pcnet patch (faster NIC, add -nic-pcnet to use it)
- fix qvm86 description (only runs on kernels without PAE)
- enforce using gcc3.3

* Sat Jun 04 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.0-7mdk
- minor optimizations to x86-64 host:
  * support direct jumps
  * assembly optimizations to softmmu mode

* Thu Jun 02 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.7.0-6mdk
- fix build with gcc4 (Paul Brook)
- fix build with gcc4 on x86_64 and local dot symbols
- fix x86-64 system emulation regression introduced from qvm86 patch

* Wed Jun 01 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.7.0-5mdk
- refactor buildrequires
- add support for -sheep-net network emulation

* Tue May 17 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.7.0-4mdk
- remove double free in slirp code
- 64-bit fixes to -user-net
- cross-compilation fixes to mingw32 from 64-bit host
- selected fixes from CVS (2005/05/17):
  * Windows 2000 install disk full hack (with -win2k-hack)
  * BMDMA interrupt fix (aka Solaris x86 IDE bug fix)
  * ne2000 reset fix (aka OS/2 Warp V4 fix)
  * handle the case where several PCI irqs share the same PIC irq
  * open fix in Linux/ARM user emulation
  * ARM saturating arithmetic fixes
  * ARM VFP dump fix
  * PPC dcbz fix

* Fri May 13 2005 Pascal Terjan <pterjan@mandriva.org> 0.7.0-3mdk
- Support qvm86 instead

* Wed May 11 2005 Pascal Terjan <pterjan@mandriva.org> 0.7.0-2mdk
- Enable kqemu support

* Fri Apr 29 2005 Pascal Terjan <pterjan@mandriva.org> 0.7.0-1mdk
- 0.7.0
- regenerate P1
- add new targets

* Sun Nov 14 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.6.1-1mdk
- 0.6.1
- build sparc target
- add initial sparc host cpu support
- drop P0, P2 & P3 (merged upstream)
- regenerate P1

* Wed Sep 29 2004 Michael Scherer <misc@mandrake.org> 0.6.0-2mdk 
- fix memleak of userspace-net-stack, ( http://lists.gnu.org/archive/html/qemu-devel/2004-09/msg00244.html )

* Mon Sep 06 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.6.0-1mdk
- 0.6.0
- updates from CVS (2004/09/06):
  * fix x86 bound instruction
  * fix build on x86 with asm memory helpers
  * fix build on ppc

